/*
 * Created on 10.03.2008
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 * 
 * New version using the Apache Commons Configuration package
 * 
 */
package de.oc.excel;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;
import org.apache.commons.lang.exception.NestableException;

import net.sf.jxls.transformer.XLSTransformer;

import org.apache.commons.beanutils.RowSetDynaClass;
import org.apache.commons.configuration.Configuration;
import org.apache.commons.configuration.PropertiesConfiguration;

public class OracleQuery {

	public static void main(String[] args) throws Exception,
			ClassNotFoundException, SQLException, NestableException {
		Connection conn;

		String propFileName = "";
		String sql = "";

		if (args.length == 1) {
			propFileName = args[0];
		} else {
			System.out.println("no parameter file given");
			System.exit(1);
		}

		FileToString fileToString = new FileToString();

		System.out.println("Read properties file " + propFileName);

		Configuration config = new PropertiesConfiguration(propFileName);

		try {
			/*
			 * Connect to database
			 */
			DriverManager.registerDriver(new oracle.jdbc.OracleDriver());

			conn = DriverManager.getConnection(config.getString("sql.jdbcUrl"),
					config.getString("sql.user"), config
							.getString("sql.password"));
			System.out.println("successfully connected to "
					+ config.getString("sql.jdbcUrl"));

			/*
			 * Initialize
			 */
			Map beans = new HashMap();

			/*
			 * Loop over all data sources
			 */
			
			String[] templateMaps = config.getStringArray("templateMap");
			String[] queryFiles = config.getStringArray("sql.queryFile");
			ResultSet rs = null;
			RowSetDynaClass rsdc = null;

			for (int i = 0; i < templateMaps.length; i++){
				sql = fileToString.readFileContents(queryFiles[i]);
				rs = conn.createStatement().executeQuery(sql);
				rsdc = new RowSetDynaClass(rs, true);

				beans.put(templateMaps[i], rsdc.getRows());
			}

			/*
			 * Generate excel file from template
			 */
			XLSTransformer transformer = new XLSTransformer();
			transformer.transformXLS(config.getString("templateFileName"),
					beans, config.getString("outputFileName"));

			/*
			 * cleanup
			 */
			rsdc = null;
			if (rs != null) rs.close();
			if (conn != null) conn.close();

			System.out.println("Output file "
					+ config.getString("outputFileName")
					+ " generated using template file "
					+ config.getString("templateFileName"));

		} catch (SQLException e) {
			System.out.println("Caught: " + e);
			System.exit(1);
		}
	}
}
